> ## Documentation Index
> Fetch the complete documentation index at: https://www.cashfree.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Fetch Details of a Single Payment

> Use this API to fetch details of a single payment of a subscription.



## OpenAPI

````yaml /openapi/payments/v2025-01-01.yaml get /subscriptions/{subscription_id}/payments/{payment_id}
openapi: 3.0.0
info:
  version: '2025-01-01'
  title: Cashfree Payment Gateway APIs
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  contact:
    email: developers@cashfree.com
    name: API Support
    url: https://discord.com/invite/QdZkNSxXsB
  description: >-
    Cashfree's Payment Gateway APIs provide developers with a streamlined
    pathway to integrate advanced payment processing capabilities into their
    applications, platforms and websites.
servers:
  - url: https://sandbox.cashfree.com/pg
    description: Sandbox server.
  - url: https://api.cashfree.com/pg
    description: Production server.
security: []
tags:
  - name: Orders
    description: Collection of APIs to handle orders.
  - name: Payments
    description: Collection of APIs to handle payments.
  - name: Refunds
    description: Collection of APIs to handle refunds.
  - name: Settlements
    description: Collection of APIs to handle settlements.
  - name: Payment Links
    description: Collection of APIs to handle payment links.
  - name: Token Vault
    description: >-
      Collection of APIs to use Cashfree's token Vault. This helps you save
      cards and tokenize them in a PCI complaint manner. We support creation of
      network tokens which can be used across acquiring banks.
  - name: softPOS
    description: Collection of APIs to manage softPOS' agent and order.
  - name: Offers
    description: Collection of APIs to handle offers.
  - name: Eligibility
    description: >-
      Collection of APIs to check eligibile entities - payment methods, offer,
      affordibility.
  - name: Settlement Reconciliation
    description: Collection of APIs to handle settlements.
  - name: PG Reconciliation
    description: Collection of APIs to handle reconciliation.
  - name: Customers
    description: Collection of APIs to handle customers.
  - name: Easy-Split
    description: Collection of APIs to handle Easy-Split.
  - name: Simulation
    description: Collection of APIs to handle simulation.
  - name: Disputes
    description: Collection of APIs to handle disputes.
  - name: Utilities
    description: Collection of APIs for utility requirement.
  - name: Downtimes
    description: Collection of APIs for managing downtimes.
externalDocs:
  url: https://api.cashfree.com/pg
  description: This url will have the information of all the APIs.
paths:
  /subscriptions/{subscription_id}/payments/{payment_id}:
    get:
      tags:
        - Subscription
      summary: Fetch Details of a Single Payment
      description: Use this API to fetch details of a single payment of a subscription.
      operationId: SubsFetchSubscriptionPayment
      parameters:
        - $ref: '#/components/parameters/apiVersionHeader'
        - $ref: '#/components/parameters/xRequestIDHeader'
        - $ref: '#/components/parameters/xIdempotencyKeyHeader'
        - $ref: '#/components/parameters/subscriptionIdParam'
        - $ref: '#/components/parameters/subscriptionPaymentIdParam'
      responses:
        '200':
          description: >-
            Success response for fetching details of a single payment of a
            subscription.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SubscriptionPaymentEntity'
          headers:
            x-api-version:
              $ref: '#/components/headers/x-api-version'
            x-ratelimit-limit:
              $ref: '#/components/headers/x-ratelimit-limit'
            x-ratelimit-remaining:
              $ref: '#/components/headers/x-ratelimit-remaining'
            x-ratelimit-retry:
              $ref: '#/components/headers/x-ratelimit-retry'
            x-ratelimit-type:
              $ref: '#/components/headers/x-ratelimit-type'
            x-request-id:
              $ref: '#/components/headers/x-request-id'
        '400':
          $ref: '#/components/responses/Response400'
        '401':
          $ref: '#/components/responses/Response401'
        '404':
          $ref: '#/components/responses/Response404'
        '429':
          $ref: '#/components/responses/Response429'
        '500':
          $ref: '#/components/responses/Response500'
      deprecated: false
      security:
        - XClientID: []
          XClientSecret: []
        - XClientID: []
          XPartnerAPIKey: []
        - XClientID: []
          XClientSignatureHeader: []
        - XPartnerMerchantID: []
          XPartnerAPIKey: []
components:
  parameters:
    apiVersionHeader:
      in: header
      name: x-api-version
      required: true
      description: API version to be used. Format is in YYYY-MM-DD.
      schema:
        type: string
        description: API version to be used.
        default: '2025-01-01'
      example: '2025-01-01'
      x-ignore: true
    xRequestIDHeader:
      in: header
      name: x-request-id
      description: >-
        Request ID for the API call. Can be used to resolve tech issues.
        Communicate this in your tech related queries to Cashfree.
      required: false
      schema:
        type: string
      example: 4dfb9780-46fe-11ee-be56-0242ac120002
    xIdempotencyKeyHeader:
      in: header
      name: x-idempotency-key
      required: false
      description: >
        An idempotency key is a unique identifier you include with your API
        call.

        If the request fails or times out, you can safely retry it using the
        same key to avoid duplicate actions.
      schema:
        type: string
        format: UUID
      example: 47bf8872-46fe-11ee-be56-0242ac120002
    subscriptionIdParam:
      name: subscription_id
      in: path
      example: subscription-id-123
      required: true
      description: Provide the Subscription ID using which the subscription was created.
      schema:
        type: string
    subscriptionPaymentIdParam:
      name: payment_id
      in: path
      example: payment-id-123
      required: true
      description: Provide the Payment ID using which the payment was created.
      schema:
        type: string
  schemas:
    SubscriptionPaymentEntity:
      title: SubscriptionPaymentEntity
      description: >-
        The response returned in Get, Create or Manage Subscription Payment
        APIs.
      type: object
      example:
        authorization_details:
          authorization_amount: 1
          authorization_amount_refund: true
          start_time: '2024-04-18T16:40:00'
          authorization_reference: osduh20ijegaoinfbBjuweod31@upi
          authorization_time: '2025-06-01T16:45:00'
          authorization_status: ACTIVE
          payment_id: test-payment-id
          payment_group: upi
          payment_method:
            upi:
              channel: collect
              upi_id: test@upi
              upi_instrument: upiInstrument
              upi_instrument_number: '1234567890'
              upi_payer_account_number: '039861903074'
              upi_payer_ifsc: SBIN0001234
        cf_payment_id: '123456'
        cf_txn_id: '123456'
        cf_order_id: '123456'
        cf_subscription_id: '7891011'
        failure_details:
          failure_reason: ''
        payment_amount: 1
        payment_id: test-payment-id
        payment_initiated_date: 2025-06-01T22:14:58+0530
        payment_remarks: authpayment
        payment_schedule_date: ''
        payment_status: SUCCESS
        payment_type: AUTH
        retry_attempts: 0
        subscription_id: test-subscription-id
      properties:
        authorization_details:
          $ref: '#/components/schemas/AuthorizationDetails'
        cf_payment_id:
          type: string
          description: Cashfree subscription payment reference number.
        cf_subscription_id:
          type: string
          description: Cashfree subscription reference number.
        cf_txn_id:
          type: string
          description: Cashfree subscription payment transaction ID.
        cf_order_id:
          type: string
          description: Cashfree subscription payment order ID.
        failure_details:
          type: object
          properties:
            failure_reason:
              type: string
              description: Failure reason of the payment if the payment_status is failed.
        payment_amount:
          type: number
          format: float64
          description: The charge amount of the payment.
        payment_id:
          type: string
          description: A unique ID passed by merchant for identifying the transaction.
        payment_initiated_date:
          type: string
          description: >-
            The date on which the payment was initiated. Cashfree stores
            timestamps in IST.
          format: ISO8601
          example: '2025-06-01T10:20:12+05:30'
        payment_remarks:
          type: string
          description: Payment remarks.
        payment_schedule_date:
          type: string
          description: >-
            The date on which the payment is scheduled to be processed. Cashfree
            stores timestamps in IST, but you can provide them in a valid ISO
            8601 time format.


            For IST this `2025-06-01T10:20:12+05:30` translates to `2025-06-01
            10:20:12` 

             For UTC this `2025-06-01T10:20:12Z` translates to `2025-06-01 15:50:12+05:30`.
        payment_status:
          type: string
          description: Status of the payment.
        payment_type:
          type: string
          description: Payment type. Can be AUTH or CHARGE.
        retry_attempts:
          type: integer
          description: Retry attempts.
        subscription_id:
          type: string
          description: A unique ID passed by merchant for identifying the subscription.
    AuthorizationDetails:
      title: AuthorizationDetails
      description: >-
        Details of the authorization done for the subscription. Returned in Get
        subscription and payments.
      type: object
      example:
        authorization_amount: 1
        authorization_amount_refund: false
        authorization_reference: ''
        authorization_time: '2025-06-01T23:47:52+05:30'
        authorization_status: INITIALIZED
        payment_id: '97877'
        payment_group: upi
        payment_method:
          upi:
            channel: collect
            upi_id: test@upi
            upi_instrument: upiInstrument
            upi_instrument_number: '1234567890'
            upi_payer_account_number: '039861903074'
            upi_payer_ifsc: SBIN0001234
      properties:
        authorization_amount:
          type: number
          format: float64
          description: >-
            Authorization amount for the auth payment. Please note that
            authorization_amount will always be 0 for ENACH.
        authorization_amount_refund:
          type: boolean
          description: >-
            Indicates whether the authorization amount should be refunded to the
            customer automatically. Merchants can use this field to specify if
            the authorized funds should be returned to the customer after
            authorization of the subscription.
        authorization_reference:
          type: string
          description: >-
            Authorization reference. UMN for UPI, UMRN for EMandate/Physical
            Mandate and Enrollment ID for cards.
        authorization_time:
          type: string
          description: Authorization time. Cashfree stores timestamps in IST.
          format: ISO8601
          example: '2025-06-01T10:20:12+05:30'
        authorization_status:
          type: string
          description: Status of the authorization.
        payment_id:
          type: string
          description: A unique ID passed by merchant for identifying the transaction.
        payment_group:
          type: string
          description: Payment group used for the authorization.
        payment_method:
          type: object
          properties:
            upi:
              $ref: '#/components/schemas/AuthResponseUpi'
            enach:
              $ref: '#/components/schemas/AuthResponseEnach'
            pnach:
              $ref: '#/components/schemas/AuthResponsePnach'
            card:
              $ref: '#/components/schemas/AuthResponseCard'
    BadRequestError:
      title: BadRequestError
      description: Invalid request received from client.
      example:
        message: bad URL, please check API documentation
        help: >-
          Check latest errors and resolution from Merchant Dashboard API logs:
          https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9
        code: request_failed
        type: invalid_request_error
      type: object
      properties:
        message:
          type: string
        code:
          type: string
        help:
          type: string
        type:
          type: string
          enum:
            - invalid_request_error
    AuthenticationError:
      title: AuthenticationError
      description: Error if api keys are wrong.
      example:
        message: authentication Failed
        code: request_failed
        type: authentication_error
      type: object
      properties:
        message:
          type: string
        code:
          type: string
        type:
          type: string
          description: authentication_error.
    ApiError404:
      title: ApiError404
      description: Error when resource requested is not found.
      example:
        message: something is not found
        help: >-
          Check latest errors and resolution from Merchant Dashboard API logs:
          https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9
        code: something_not_found
        type: invalid_request_error
      type: object
      properties:
        message:
          type: string
        code:
          type: string
        help:
          type: string
        type:
          type: string
          enum:
            - invalid_request_error
          description: invalid_request_error.
    RateLimitError:
      title: RateLimitError
      description: Error when rate limit is breached for your api.
      example:
        message: Too many requests from IP. Check headers
        code: request_failed
        type: rate_limit_error
      type: object
      properties:
        message:
          type: string
        code:
          type: string
        type:
          type: string
          enum:
            - rate_limit_error
          description: rate_limit_error.
    ApiError:
      title: ApiError
      description: Error at Cashfree's server.
      example:
        message: internal Server Error
        help: >-
          Check latest errors and resolution from Merchant Dashboard API logs:
          https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9
        code: internal_error
        type: api_error
      type: object
      properties:
        message:
          type: string
        code:
          type: string
        help:
          type: string
        type:
          type: string
          enum:
            - api_error
          description: api_error.
    AuthResponseUpi:
      description: Payment method upi.
      type: object
      title: Upi Auth Response
      properties:
        channel:
          description: Can be link, qrcode, or collect.
          type: string
        upi_id:
          description: Virtual payment address (UPI ID) of the user.
          type: string
        upi_instrument:
          description: UPI instrument used for payment.
          type: string
        upi_instrument_number:
          description: Unique number representing the UPI instrument.
          type: string
        upi_payer_account_number:
          description: Account number of the UPI payer.
          type: string
        upi_payer_ifsc:
          description: IFSC code of the UPI payer's bank.
          type: string
    AuthResponseEnach:
      description: Payment method enach.
      type: object
      title: Enach Auth Response
      properties:
        channel:
          description: Channel. Can be link.
          type: string
        auth_mode:
          description: Auth mode. Can be debit_card, aadhaar, or net_banking.
          type: string
        account_type:
          description: Type of the bank account.
          type: string
        account_number:
          description: Bank account number.
          type: string
        account_ifsc:
          description: IFSC code of the bank account.
          type: string
        account_holder_name:
          description: Name of the account holder.
          type: string
        account_bank_code:
          description: Bank code of the account-holding bank.
          type: string
    AuthResponsePnach:
      description: Payment method pnach.
      type: object
      title: Pnach Auth Response
      properties:
        channel:
          description: Channel. Can be post.
          type: string
        mandate_creation_date:
          description: >-
            Date on which the mandate was created. Cashfree stores timestamps in
            IST.
          type: string
          format: ISO8601
          example: '2025-06-01T10:20:12+05:30'
        mandate_start_date:
          description: Start date of the mandate. Cashfree stores timestamps in IST.
          type: string
          format: ISO8601
          example: '2025-06-01T10:20:12+05:30'
        account_type:
          description: Type of the bank account.
          type: string
        account_number:
          description: Bank account number.
          type: string
        account_ifsc:
          description: IFSC code of the bank account.
          type: string
        account_holder_name:
          description: Name of the account holder.
          type: string
        account_bank_code:
          description: Bank code of the account-holding bank.
          type: string
    AuthResponseCard:
      description: Payment method card.
      type: object
      title: Card Auth Response
      properties:
        channel:
          description: Can be link.
          type: string
        card_number:
          description: Card number.
          type: string
        card_network:
          description: Card network (e.g., VISA, Mastercard).
          type: string
        card_type:
          description: Card type (e.g., credit_card).
          type: string
        card_sub_type:
          description: Card subtype (e.g., R).
          type: string
        card_country:
          description: Country of the card (e.g., IN).
          type: string
        card_bank_name:
          description: Bank name on card.
          type: string
        card_network_reference_id:
          description: Network reference ID.
          type: string
        instrument_id:
          description: Unique identifier for card instrument.
          type: string
  headers:
    x-api-version:
      schema:
        type: string
        format: YYYY-MM-DD
        enum:
          - '2025-01-01'
      description: >-
        This header has the version of the API. The current version is
        `2025-01-01`.
    x-ratelimit-limit:
      schema:
        type: integer
      example: 200
      description: Ratelimit set for your account for this API per minute.
    x-ratelimit-remaining:
      schema:
        type: integer
      example: 2
      description: >-
        Rate limit remaning for your account for this API in the next minute.
        Uses sliding window.
    x-ratelimit-retry:
      schema:
        type: integer
      example: 4
      description: |
        Contains number of seconds to wait if rate limit is breached
        - Is 0 if withing the limit
        - Is between 1 and 59 if breached
    x-ratelimit-type:
      schema:
        type: string
        enum:
          - app_id
          - ip
      example: ip
      description: >
        either ip or app_id

        - `ip` if making a call from the browser. True for api where you don't
        need `x-client-id` and `x-client-secret`

        - `app_id` for authenticated api calls i.e using `x-client-id` and
        `x-client-secret`
    x-request-id:
      schema:
        type: string
      example: some-req-id
      description: >-
        Request id for your api call. Is blank or null if no `x-request-id` is
        sent during the request.
    x-idempotency-key:
      schema:
        type: string
      example: some-idem-id
      description: >-
        An idempotency key is a unique identifier you include with your API
        call. If the request fails or times out, you can safely retry it using
        the same key to avoid duplicate actions.
    x-idempotency-replayed:
      schema:
        type: string
        format: boolean
      example: 'true'
      description: |-
        In conjunction with `x-idempotency-key` this means
        - `true` if the response was replayed
        - `false` if the response has not been replayed.
  responses:
    Response400:
      description: Bad request error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/BadRequestError'
      headers:
        x-api-version:
          $ref: '#/components/headers/x-api-version'
        x-ratelimit-limit:
          $ref: '#/components/headers/x-ratelimit-limit'
        x-ratelimit-remaining:
          $ref: '#/components/headers/x-ratelimit-remaining'
        x-ratelimit-retry:
          $ref: '#/components/headers/x-ratelimit-retry'
        x-ratelimit-type:
          $ref: '#/components/headers/x-ratelimit-type'
        x-request-id:
          $ref: '#/components/headers/x-request-id'
        x-idempotency-key:
          $ref: '#/components/headers/x-idempotency-key'
        x-idempotency-replayed:
          $ref: '#/components/headers/x-idempotency-replayed'
    Response401:
      description: Authentication Error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/AuthenticationError'
      headers:
        x-api-version:
          $ref: '#/components/headers/x-api-version'
        x-ratelimit-limit:
          $ref: '#/components/headers/x-ratelimit-limit'
        x-ratelimit-remaining:
          $ref: '#/components/headers/x-ratelimit-remaining'
        x-ratelimit-retry:
          $ref: '#/components/headers/x-ratelimit-retry'
        x-ratelimit-type:
          $ref: '#/components/headers/x-ratelimit-type'
        x-request-id:
          $ref: '#/components/headers/x-request-id'
        x-idempotency-key:
          $ref: '#/components/headers/x-idempotency-key'
        x-idempotency-replayed:
          $ref: '#/components/headers/x-idempotency-replayed'
    Response404:
      description: Resource Not found.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiError404'
      headers:
        x-api-version:
          $ref: '#/components/headers/x-api-version'
        x-ratelimit-limit:
          $ref: '#/components/headers/x-ratelimit-limit'
        x-ratelimit-remaining:
          $ref: '#/components/headers/x-ratelimit-remaining'
        x-ratelimit-retry:
          $ref: '#/components/headers/x-ratelimit-retry'
        x-ratelimit-type:
          $ref: '#/components/headers/x-ratelimit-type'
        x-request-id:
          $ref: '#/components/headers/x-request-id'
        x-idempotency-key:
          $ref: '#/components/headers/x-idempotency-key'
        x-idempotency-replayed:
          $ref: '#/components/headers/x-idempotency-replayed'
    Response429:
      description: Rate Limit Error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/RateLimitError'
      headers:
        x-api-version:
          $ref: '#/components/headers/x-api-version'
        x-ratelimit-limit:
          $ref: '#/components/headers/x-ratelimit-limit'
        x-ratelimit-remaining:
          $ref: '#/components/headers/x-ratelimit-remaining'
        x-ratelimit-retry:
          $ref: '#/components/headers/x-ratelimit-retry'
        x-ratelimit-type:
          $ref: '#/components/headers/x-ratelimit-type'
        x-request-id:
          $ref: '#/components/headers/x-request-id'
        x-idempotency-key:
          $ref: '#/components/headers/x-idempotency-key'
        x-idempotency-replayed:
          $ref: '#/components/headers/x-idempotency-replayed'
    Response500:
      description: API related Error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiError'
      headers:
        x-api-version:
          $ref: '#/components/headers/x-api-version'
        x-ratelimit-limit:
          $ref: '#/components/headers/x-ratelimit-limit'
        x-ratelimit-remaining:
          $ref: '#/components/headers/x-ratelimit-remaining'
        x-ratelimit-retry:
          $ref: '#/components/headers/x-ratelimit-retry'
        x-ratelimit-type:
          $ref: '#/components/headers/x-ratelimit-type'
        x-request-id:
          $ref: '#/components/headers/x-request-id'
        x-idempotency-key:
          $ref: '#/components/headers/x-idempotency-key'
        x-idempotency-replayed:
          $ref: '#/components/headers/x-idempotency-replayed'
  securitySchemes:
    XClientID:
      type: apiKey
      in: header
      name: x-client-id
      description: >-
        Client app ID. You can find your app id in the [Merchant
        Dashboard](https://merchant.cashfree.com/auth/login/pg/developers/api-keys?env=prod).
    XClientSecret:
      type: apiKey
      in: header
      name: x-client-secret
      description: >-
        Client secret key. You can find your secret key in the [Merchant
        Dashboard](https://merchant.cashfree.com/auth/login/pg/developers/api-keys?env=prod).
    XPartnerAPIKey:
      type: apiKey
      in: header
      name: x-partner-apikey
      description: >-
        If you are partner and you are making an api call on behalf of a
        merchant.
    XClientSignatureHeader:
      type: apiKey
      in: header
      name: x-client-signature
      description: >-
        Use this if you do not want to pass the secret key and instead want to
        use signature.
    XPartnerMerchantID:
      type: apiKey
      in: header
      name: x-partner-merchantid
      description: >-
        If you are partner use this to specify the merchant ID if you don't have
        the merchant client app ID.

````